package com.loafle.overflow.service.central.sensor;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.core.model.PageParams;
import com.loafle.overflow.model.sensor.Sensor;
import com.loafle.overflow.model.sensor.SensorItem;
import org.springframework.data.domain.Page;

import java.util.List;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface SensorService  {
    @WebappAPI
    Sensor regist(Sensor sensor) throws OverflowException;
    @WebappAPI
    Sensor read(String id) throws OverflowException;
    @WebappAPI
    void remove(String id) throws OverflowException;
    @WebappAPI
    Sensor start(String id) throws OverflowException;
    @WebappAPI
    Sensor stop(String id) throws OverflowException;
    @WebappAPI
    Sensor registSensorConfig(Sensor sensor, List<SensorItem> sensorItemList, String etcJson) throws OverflowException;
    @WebappAPI
    String generateSensorConfig(Sensor sensor) throws OverflowException;

    @WebappAPI
    Page<Sensor> readAllByDomainID(long domainID, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Sensor> readAllByInfraID(long infraID, PageParams pageParams) throws OverflowException;
    @WebappAPI
    Page<Sensor> readAllByTargetID(long targetID, PageParams pageParams) throws OverflowException;
}
